Option Explicit

'' elec.vbs
'' 2022/01/12
'' f.izawa

'' 2022/03/10
''   XTERM P̎ɑΉ
''   Select ̃tB^[ǉ
'' 2022/03/11 
''   XTERM ̎ɑΉ
''  i͒̃yA̔fKv͖Ήj
'' 2022/03/17
''   XTERM ̎ɑΉ(قڊS)
''   JIS-C-0617 V{ɑΉ

call main()

Function Distance(pt1, pt2)
	Distance = Sqr((pt1(0) - pt2(0)) ^ 2 + (pt1(1) - pt2(1)) ^ 2)	
End Function

Function Angle(pt1, pt2)
	Const Pi = 3.1415926535897932
	Dim dx, dy, ang
	dx = pt2(0) - pt1(0)
	dy = pt2(1) - pt1(1)
	if Abs(dx) <= 0.000001 Then
		If dy >= 0 Then
			ang = Pi * 0.5
		Else
			ang = Pi * 1.5
		End If
	Else
		if Abs(dy) <= 0.000001 Then
			If dx >= 0 Then
				ang = 0.0
			Else
				ang = Pi
			End If
		Else
			ang = Abs(Atn(dy / dx))
			If (dx < 0.0) And (dy >= 0.0) Then
				ang = Pi - ang
			ElseIf (dx >= 0.0) And (dy < 0.0) Then
				ang = Pi * 2 - ang
			ElseIf (dx < 0.0) and (dy < 0.0) Then
				ang = Pi + ang
			End If
		End If
	End If
	Angle = ang
End Function

'' 2ł邩
Function canBeJoint(pt1A, pt1B, pt2A, pt2B)
	Dim ang: ang = Angle(pt1A, pt1B)
	Dim lg1: lg1 = Distance(pt1A, pt2A) * Sin(ang - Angle(pt1A, pt2A))
	Dim lg2: lg2 = Distance(pt1A, pt2B) * Sin(ang - Angle(pt1A, pt2B))
	canBeJoint = Abs(lg1) < 0.00001 and Abs(lg2) < 0.00001
End Function

function nearEqual(v1, v2, faz)
	nearEqual = abs(v1 - v2) < faz
end function

sub Polar(p0, rad, dist, byref resPt)
	Const PI = 3.1415926535897932
	dim faz, i
	faz = 10e-6
	for i = 0 to 2: resPt(i) = p0(i): next

   	if nearEqual(rad, 0, faz) then
    	resPt(0) = dist + p0(0)
  	elseif nearEqual(rad, PI/2, faz) then
    	resPt(1) = dist + p0(1)
	elseif nearEqual(rad, PI, faz) then
    	resPt(0) = p0(0) - dist
	elseif nearEqual(rad, PI * 1.5, faz) then
    	resPt(1) = p0(1) - dist
	else
    	resPt(0) = dist * cos(rad) + p0(0)
    	resPt(1) = dist * sin(rad) + p0(1)
	end if
end sub

function Inters(p1, p2, p3, p4, extflag, byref respt)
  dim f1, f2, g1, g2, h, m, n
  Inters = False
  f1 = p2(0) - p1(0)
  f2 = p4(0) - p3(0)
  g1 = p2(1) - p1(1)
  g2 = p4(1) - p3(1)
  h = f2 * g1 - f1 * g2
  if abs(h) > 10e-13 then 'słȂ
    m = (f2 * (p3(1) - p1(1)) - g2 * (p3(0) - p1(0))) / h
    n = (f1 * (p3(1) - p1(1)) - g1 * (p3(0) - p1(0))) / h
    if (((n >= 10e-13) and (n <= 1)) and ((m >= 10e-13) and (m <= 1))) or not extFlag then '_ɑ
      respt(0) = p1(0) + m * (p2(0) - p1(0))
      respt(1) = p1(1) + m * (p2(1) - p1(1))
      respt(2) = p1(2)
      Inters = True
    end if
  end if
end function

Sub maxDist4(pt1, pt2, pt3, pt4, ByRef resPt1, ByRef resPt2)
	Dim arr(3)
	arr(0) = pt1
	arr(1) = pt2
	arr(2) = pt3
	arr(3) = pt4
	Dim i, j, k, dist
	Dim maxDist: maxDist = 0
	For i = 0 To 2
		For j = i + 1 To 3
			dist = Distance(arr(i), arr(j))
			If dist > maxDist Then
				maxDist = dist
				For k = 0 to 2
					resPt1(k) = arr(i)(k)
					resPt2(k) = arr(j)(k)
				Next	
			End If
		Next
	Next
End Sub

Sub midPoint(pt1, pt2, ByRef res)
	Dim i: For i = 0 To 2: res(i) = (pt1(i) + pt2(i)) / 2: Next
End Sub

Function inArea(pt, minExt, maxExt)
	inArea = pt(0) >= minExt(0) and pt(1) >= minExt(1) and _
			   pt(0) <= maxExt(0) and pt(1) <= maxExt(1)
End Function

sub lineWindow(p1, p2, off, byref pmin, byref pmax)
	dim i
	for i = 0 to 1
		if p1(i) < p2(i) then pmin(i) = p1(i) else pmin(i) = p2(i)
		if p1(i) > p2(i) then pmax(i) = p1(i) else pmax(i) = p2(i)
	next
	for i = 0 to 1
		pmin(i) = pmin(i) - off
		pmax(i) = pmax(i) + off
	next
end sub

'' 2022/03/10 ǉ
sub pointWindow(pt, off, byref pmin, byref pmax)
	dim i
	for i = 0 to 1
		pmin(i) = pt(i) - off
		pmax(i) = pt(i) + off
	next
end sub

' 
' 2022/01/13 wE킪ĂƂ͌Ȃ
sub jointLines(blkPos, minExt, maxExt)
	Const PI = 3.1415926535897932
	dim ut: Set ut = ThisDrawing.Utility
	Dim selSet: Set selSet = ThisDrawing.ActiveSelectionSet
	selSet.Clear
	Call selSet.Select(acSelectionSetCrossing, minExt, maxExt, 0, "LINE")
	If selset.Count >= 2 Then
		Dim obj1, obj2, stPt1, edpt1, stpt2, edpt2, respt1(2), respt2(2)
		Dim i, j
		For i = selSet.Count - 1 To 1 Step -1
			Set obj1 = selSet.Item(i)
			If obj1.EntityName = "AcDbLine" Then
				stpt1 = ut.CreateSafeArrayFromVector(obj1.StartPoint)
				edpt1 = ut.CreateSafeArrayFromVector(obj1.EndPoint)
				For j = i - 1 To 0 Step -1
					Set obj2 = selSet.Item(j)
					If (obj2.EntityName = "AcDbLine") Then
						stpt2 = ut.CreateSafeArrayFromVector(obj2.StartPoint)
						edpt2 = ut.CreateSafeArrayFromVector(obj2.EndPoint)		
						If canBeJoint(stPt1, edpt1, stpt2, edpt2) Then
							if (obj1.Layer = obj2.Layer) and (obj1.Linetype = obj2.Linetype) then		
								Call maxDist4(stPt1, edpt1, stpt2, edpt2, respt1, respt2)
								obj2.StartPoint = respt1
								obj2.EndPoint = respt2
								obj2.Update
								obj1.Delete
								Exit For
							End If
						end if
					End If
					Set obj2 = Nothing
				Next
			End If
			Set obj1 = Nothing
		Next
	End If
	'' ubN̒S܂ŉ
	selSet.Clear
	dim pt(2), ip(2)
	Call selSet.Select(acSelectionSetCrossing, minExt, maxExt, 0, "LINE")
	If selset.Count >= 1 Then
		For i = 0 to selSet.Count - 1 
			Set obj1 = selSet.Item(i)
			If obj1.EntityName = "AcDbLine" Then
				stpt1 = ut.CreateSafeArrayFromVector(obj1.StartPoint)
				edpt1 = ut.CreateSafeArrayFromVector(obj1.EndPoint)
				call polar(blkpos, angle(stpt1, edpt1) + PI/2, 100, pt)
				if inArea(stpt1, minExt, maxExt) then
					if inters(stpt1, edpt1, blkpos, pt, false, ip) then
						obj1.StartPoint = ip
					end if
				elseif inArea(edpt1, minExt, maxExt) then
					if inters(stpt1, edpt1, blkpos, pt, false, ip) then
						obj1.EndPoint = ip
					end if					
				end if
				obj1.Update				
			end if
		next
	end if
	selSet.Clear
	Set selSet = Nothing
	Set ut = Nothing
end sub

'' *******************************
'' Entity ubN}`̋`͈͂𓾂
'' *******************************
'' ubN̐}`𐧌AĂ}`Ώ
Function blockRect(blkObj, ByRef minExt, ByRef maxExt)
	dim ut: set ut = ThisDrawing.Utility '' 2022/03/10
	Dim sEntityNames
	sEntityNames = "AcDbArc AcDbLine AcDbCircle AcDbPolyline" 
	'' `͈͂̏l
	maxExt(0) = -42000.0
	maxExt(1) = -29700.0
	maxExt(2) = 0.0
	minExt(0) = 42000.0
	minExt(1) = 29700.0
	minExt(2) = 0.0	

	Dim cnt: cnt = 0
	If blkObj.EntityName = "AcDbBlockReference" Then
		Dim expObjs, vminExt, vmaxExt		
		'' 
		expObjs = blkObj.Explode
		Dim obj, pt, i
		'' }`̒
		for i = 0 to UBound(expObjs)
			Set obj = expObjs(i)
			if InStr(sEntityNames, obj.EntityName) > 0 Then
				if IsLayerOn(obj.Layer) Then
					obj.GetBoundingBox vminExt, vmaxExt
					pt = ut.CreateSafeArrayFromVector(vminExt)
					if pt(0) < minExt(0) then minExt(0) = pt(0)
					if pt(1) < minExt(1) then minExt(1) = pt(1)
					pt = ut.CreateSafeArrayFromVector(vmaxExt)
					if pt(0) > maxExt(0) then maxExt(0) = pt(0)
					if pt(1) > maxExt(1) then maxExt(1) = pt(1)
					cnt = cnt + 1
				End If
			End If
			'' }`폜
			obj.Delete
			Set obj = Nothing
		Next	
	End If
	blockRect = cnt > 0
	set ut = Nothing
End Function

' *******************************
' Layer  ON  Freeze łȂ
' *******************************
Function IsLayerOn(layName)
	IsLayerOn = False
	Dim lays: Set lays = ThisDrawing.Layers
	Dim lay, i
	For i = 0 To lays.Count - 1 
		Set lay = lays.item(i)
		if lay.Name = layName Then
			IsLayerOn = lay.LayerOn and not lay.Freeze
			Exit For
		End If
		Set lay = Nothing
	Next
	Set lays = Nothing	
End Function

sub breakLines(blkObj, minExt, maxExt)
	Dim selSet: Set selSet = ThisDrawing.ActiveSelectionSet
	selSet.Clear
	'' `͈͂ɂ}`I
	Call selSet.Select(acSelectionSetCrossing, minExt, maxExt, 0, "LINE")
	If selset.Count > 0 then
		Dim i
		for i = 0 to selset.Count - 1
			Dim obj: Set obj = selset.item(i)
			'' ubN̐}`ɌJbg
			If obj.EntityName = "AcDbLine" Then
				'ut.prompt "AcDbLine"
				Call doBlockTrim2(blkObj, obj, minExt, maxExt)
			End If
			Set obj = NoThing
		Next
	End If
	selSet.Clear
	Set selSet = Nothing
end sub

Sub doBlockTrim2(blkObj, byref lnObj, minExt, maxExt)
	dim ut: Set ut = ThisDrawing.Utility
	Dim sEntityNames
	sEntityNames = "AcDbArc AcDbLine AcDbCircle AcDbPolyline" 
	
	Dim stPt: stPt = ut.CreateSafeArrayFromVector(lnObj.StartPoint)
	Dim stPtOrg: stPtOrg = stPt
	
	Dim edPt: edPt = ut.CreateSafeArrayFromVector(lnObj.EndPoint)
	Dim edPtOrg: edPtOrg = edPt
	
	Dim dist: dist = Distance(stPt, edPt)
	Dim stDist: stDist = dist
	Dim edDist: edDist = dist
	
	Dim insPt: insPt = ut.CreateSafeArrayFromVector(blkObj.InsertionPoint)
	'ut.Prompt "InsertionPoint = " & insPt(0) & "," & insPt(1)

	'' 
	Dim expEnts: expEnts = blkObj.Explode
	Dim pts, pt(2), stPt2(2), edPt2(2)
	'' 2021/12/09 lǉ
	'' ̒[__̎A[_ 0,0@ɂȂ̂蒼
	Dim k
	For k = 0 To 2: stPt2(k) = edPt(k): Next
	For k = 0 To 2: edPt2(k) = stPt(k): Next
	
	Dim cnt: cnt = 0
	Dim obj, vpts, p1, p2
	For Each obj In expEnts
		'' }`Ő
		if InStr(sEntityNames, obj.EntityName) > 0 Then
			if IsLayerOn(obj.Layer) Then
				'' ƃubN}`̌_
				vpts = lnObj.IntersectWith(obj, acExtendNone)
				If VarType(vpts) = (vbArray + vbDouble) Then
					pts = ut.CreateSafeArrayFromVector(vpts)
					Dim i, j
					For i = 0 To (UBound(pts) + 1) \ 3 - 1
						'ut.Prompt pts(i * 3) & ", " & pts(i * 3 + 1)
						For j = 0 To 2: pt(j) = pts(i * 3 + j): Next
						'' _̊mF̂߂ɉ~`
						'doc.ModelSpace.AddCircle pt, 0.25
						'' n_ɋ߂_ƏI_ɋ߂_c
						dist = Distance(stPt, pt)
						if dist < stDist Then
							stDist = dist
							For j = 0 To 2: stPt2(j) = pt(j): Next
						End If
						dist = Distance(edPt, pt)
						if dist < edDist Then
							edDist = dist
							For j = 0 To 2: edPt2(j) = pt(j): Next
						End If
						cnt = cnt + 1
					Next
					'cnt = cnt + 1
				Else
					'' 2022/01/07 NewJIS ɑΉiAɌj
					if ("AcDbLine" = obj.EntityName) then
					 	p1 = ut.CreateSafeArrayFromVector(obj.StartPoint)
					 	p2 = ut.CreateSafeArrayFromVector(obj.EndPoint)
						dim f1, f2
						f1 = ((abs(p1(0) - stPtOrg(0)) < 0.001) or (abs(p1(1) - stPtOrg(1)) < 0.001))
						f2 = ((abs(p1(0) - edPtOrg(0)) < 0.001) or (abs(p1(1) - edPtOrg(1)) < 0.001))

						if f1 and f2 then
							'ThisDrawing.ModelSpace.AddCircle p1, 0.5
							dist = Distance(stPt, p1)
							if dist < stDist Then
								stDist = dist
								For j = 0 To 2: stPt2(j) = p1(j): Next
							End If
							dist = Distance(edPt, p1)
							if dist < edDist Then
								edDist = dist
								For j = 0 To 2: edPt2(j) = p1(j): Next
							End If 
							cnt = cnt + 1
						end if
						f1 = ((abs(p2(0) - stPtOrg(0)) < 0.001) or (abs(p2(1) - stPtOrg(1)) < 0.001))
						f2 = ((abs(p2(0) - edPtOrg(0)) < 0.001) or (abs(p2(1) - edPtOrg(1)) < 0.001))						
						if f1 and f2 then
							'ThisDrawing.ModelSpace.AddCircle p2, 0.5 
							dist = Distance(stPt, p2)
							if dist < stDist Then
								stDist = dist
								For j = 0 To 2: stPt2(j) = p2(j): Next
							End If
							dist = Distance(edPt, p2)
							if dist < edDist Then
								edDist = dist
								For j = 0 To 2: edPt2(j) = p2(j): Next
							End If
							cnt = cnt + 1
						end if
					end if	
				End If
			End If
		End If
		'' }`폜
		obj.Delete
	Next
	if cnt > 0 Then
		'' Ƌ`̐
		'' _P̎
		If Distance(stPt2, edPt2) < 0.0001 Then
			'' 2021-12/09 _PŁAn_-I_`͈͊O͉̎Ȃ
			If inArea(stPt, minExt, maxExt) or inArea(edPt, minExt, maxExt) Then
				Dim mpt(2): call midPoint(minExt, maxExt, mpt)
				If Distance(mpt, stPt) < Distance(mpt, edPt) Then
					lnObj.StartPoint = stPt2
					stPtOrg = stPt2
				Else
					lnObj.EndPoint = stPt2
					edPtOrg = stPt2
				End If
				lnObj.Update
				If inArea(stPtOrg, minExt, maxExt) and inArea(edPtOrg, minExt, maxExt) Then
					lnObj.Delete
				End If
			End If
		Else 
			Dim lnObj2:	Set lnObj2 = lnObj.Copy
			lnObj.EndPoint = stPt2
			lnObj.Update
			edPtOrg = stPt2
			If (lnObj.Length < 0.0001) or _
			   (inArea(stPtOrg, minExt, maxExt) and inArea(edPtOrg, minExt, maxExt)) Then
				lnObj.Delete
			End If 
			lnObj2.StartPoint = edPt2
			lnObj2.Update
			stPtOrg = edPt2
			edPtOrg = edPt
			If (lnObj2.Length < 0.0001) or _
			   (inArea(stPtOrg, minExt, maxExt) and inArea(edPtOrg, minExt, maxExt)) Then
				lnObj2.Delete
			End If
			Set lnObj2 = Nothing
		End If
	End If
	Set ut = Nothing
End Sub

function getBjeTerms(blockObj)
	dim ut: Set ut = ThisDrawing.Utility
	Dim result: result = ""
	if VarType(blockObj) = vbObject and blockObj.EntityName = "AcDbBlockReference" then
		'dim blkpos: blkpos = ut.CreateSafeArrayFromVector(blockObj.InsertionPoint)
		'ut.prompt CStr(blkpos(0)) & "," & CStr(blkpos(1))
		if blockObj.HasAttributes then
			Dim vAttribs: vAttribs = blockObj.GetConstantAttributes
			Dim i, pt, s
			for i = 0 to UBound(vAttribs)
				s = vAttribs(i).TagString
				if InStr(s, "X") = 1 and Instr(s, "TERM") = 3 then
					'ut.prompt vAttribs(i).Rotation
					pt = ut.CreateSafeArrayFromVector(vAttribs(i).InsertionPoint)
					result = result & s & "," & FormatNumber(pt(0), 4) & "," & FormatNumber(pt(1), 4) & vbTab
				end if
			next
		end if
		dim l: l = Len(result)
		if l > 0 then
			result = Left(result, l - 1)
		end if
	end if
	getBjeTerms = result
	Set ut = Nothing
end function

function toBjeTermArray(bjeTerms, byref bjeTermArray)
	bjeTermArray = split(bjeTerms, vbTab)
	toBjeTermArray = Ubound(bjeTermArray) >= 0
	if Ubound(bjeTermArray) >= 0 then
		dim i
		if Ubound(bjeTermArray) >= 1 then
			'' sort
			for i = 0 to UBound(bjeTermArray) - 1
				dim temp, j				
				'ut.Prompt mid(bjeTermArray(i), 7, 1)
				for j = i + 1 to Ubound(bjeTermArray)
					if (mid(bjeTermArray(i), 7, 1) > mid(bjeTermArray(j), 7, 1)) or _
					  ((mid(bjeTermArray(i), 7, 1) = mid(bjeTermArray(j), 7, 1)) and _
					   (mid(bjeTermArray(i), 2, 1) > mid(bjeTermArray(j), 2, 1))) then
						temp = bjeTermArray(i): bjeTermArray(i) = bjeTermArray(j): bjeTermArray(j) = temp
					end if 
				next   
			next
		end if
	end if
end function

function getBjeRect(bjeTermArray, blkpos, byref minpt, byref maxpt)
	minpt(2) = 0
	maxpt(2) = 0
	getBjeRect = Ubound(bjeTermArray) >= 0
	if Ubound(bjeTermArray) >= 0 then
		dim i, j
		'' `͈
		for i = 0 to UBound(bjeTermArray)
			dim items: items = split(bjeTermArray(i), ",")
			if i = 0 then
				for j = 0 to 1: minpt(j) = cdbl(items(j + 1)): next
				for j = 0 to 1: maxpt(j) = minpt(j): next
			else
				for j = 0 to 1
					if minpt(j) > cdbl(items(j + 1)) then minpt(j) = cdbl(items(j + 1))
					if maxpt(j) < cdbl(items(j + 1)) then maxpt(j) = cdbl(items(j + 1))
				next
			end if
		next
		for i = 0 to 1
			minpt(i) = blkpos(i) + minpt(i)
			maxpt(i) = blkpos(i) + maxpt(i)
		next
	end if
end function

' sub bjeBreakLinesOld(bjeTermArray, blkpos)
' 	dim ut: Set ut = ThisDrawing.Utility
' 	'ut.prompt UBound(bjeTermArray)
' 	Dim i, j, k
' 	Dim ss: Set ss = ThisDrawing.ActiveSelectionSet
' 	Dim item1, item2, p1(2), p2(2), mnpt(2), mxpt(2)
' 	dim obj, obj2, stpt, edpt
' 	p1(2) = 0: p2(2) = 0
' 	mnpt(2) = 0: mxpt(2) = 0	
' 	if UBound(bjeTermArray) >= 1 then
' 		'' xterm ̎́AŌオȂ 2022/03/11 
' 		'' X1TERM1,X2TERM1,X4TERM1,X8TERM1 ɖΉ 2022/03/10 
' 		for i = 0 to ((UBound(bjeTermArray) + 1) \ 2) - 1
' 			item1 = split(bjeTermArray(i * 2), ",")
' 			for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
' 			item2 = split(bjeTermArray(i * 2 + 1), ",")
' 			for j = 0 to 1: p2(j) = CDbl(item2(j + 1)) + blkpos(j): next
' 			Call lineWindow(p1, p2, 0.5, mnpt, mxpt)
' 			ss.clear
' 			Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
' 			if ss.Count > 0 then
' 				for k = 0 to ss.Count - 1
' 					Set obj = ss.Item(k)
' 					'' Jbg
' 					if obj.EntityName = "AcDbLine" then
' 						stpt = ut.CreateSafeArrayFromVector(obj.StartPoint)
' 						edpt = ut.CreateSafeArrayFromVector(obj.EndPoint)
' 						if canBeJoint(stpt, edpt, p1, p2) then
' 							'ut.prompt "canbejoint"
' 							if inArea(stpt, mnpt, mxpt) then
' 								if distance(edpt, p1) < distance(edpt, p2) then
' 									obj.StartPoint = p1
' 								else
' 									obj.StartPoint = p2
' 								end if
' 								obj.Update
' 							elseif inArea(edpt, mnpt, mxpt) then
' 								if distance(stpt, p1) < distance(stpt, p2) then
' 									obj.EndPoint = p1
' 								else
' 									obj.EndPoint = p2
' 								end if
' 								obj.Update
' 							else
' 								Set obj2 = obj.Copy
' 								if distance(stpt, p1) < distance(stpt, p2) then
' 									obj.EndPoint = p1
' 									obj2.startpoint = p2
' 								else
' 									obj.EndPoint = p2
' 									obj2.startpoint = p1
' 								end if
' 								obj.Update
' 								obj2.Update							
' 								Set obj2 = Nothing
' 							end if
' 						else
' 							'ut.prompt "not canbejoint"
' 						end if
' 					end If
' 					Set obj = Nothing
' 				next
' 			end if
' 		next
' 		'' 2022/03/11 ̎ɑΉ
' 		if (UBound(bjeTermArray) + 1) mod 2 > 0 then
' 			item1 = split(bjeTermArray(UBound(bjeTermArray)), ",")
' 			for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
' 			Call pointWindow(p1, 0.5, mnpt, mxpt)
' 			ss.clear
' 			Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
' 			if ss.Count > 0 then
' 				if ss.Count = 1 then
' 					Set obj = ss.Item(0)
' 					Set obj2 = obj.Copy
' 					obj.EndPoint = p1
' 					obj2.StartPoint = p1
' 					obj.Update
' 					obj2.Update							
' 					Set obj = Nothing
' 					Set obj2 = Nothing
' 				end if	
' 			end if			
' 		end if
' 	else
' 		' 2022/03/10
' 		' X4TERM1,0.0000,-0.0000
' 		item1 = split(bjeTermArray(0), ",")
' 		for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
' 		Call pointWindow(p1, 0.5, mnpt, mxpt)
' 		ss.clear
' 		Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
' 		if ss.Count > 0 then
' 			if ss.Count = 1 then
' 				Set obj = ss.Item(0)
' 				Set obj2 = obj.Copy
' 				obj.EndPoint = p1
' 				obj2.StartPoint = p1
' 				obj.Update
' 				obj2.Update							
' 				Set obj = Nothing
' 				Set obj2 = Nothing
' 			end if	
' 		end if
' 	end if
' 	Set ss = Nothing
' 	Set ut = Nothing
' end sub

'' 2022/03/17
'' JIS-C-0617 V{ɑΉ
sub bjeBreakLines(bjeTermArray, blkpos)
	dim ut: Set ut = ThisDrawing.Utility
	'ut.prompt UBound(bjeTermArray)
	Dim i, j, k, ii
	Dim ss: Set ss = ThisDrawing.ActiveSelectionSet
	Dim item1, item2, p1(2), p2(2), mnpt(2), mxpt(2)
	dim obj, obj2, stpt, edpt
	dim terms: terms = ""
	dim s
	dim tate1, tate2
	p1(2) = 0: p2(2) = 0
	mnpt(2) = 0: mxpt(2) = 0	
	if UBound(bjeTermArray) >= 1 then
		'' xterm ̎́AŌオȂ 2022/03/11 
		'' X1TERM1,X2TERM1,X4TERM1,X8TERM1 ɑΉĂȂ 2022/03/10 
		'' X1 or X4 JbgAX2 or X8 cJbg
		for i = 0 to UBound(bjeTermArray) - 1
			item1 = split(bjeTermArray(i), ",")
			s = Left(item1(0), 2)
			tate1 = s = "X2" or s = "X8"
			'ut.prompt item1(0)
			'ut.prompt tate1
			for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
			for ii = i + 1 to Ubound(bjeTermArray)
				item2 = split(bjeTermArray(ii), ",")
				s = Left(item2(0), 2)
				tate2 = s = "X2" or s = "X8"
				for j = 0 to 1: p2(j) = CDbl(item2(j + 1)) + blkpos(j): next
				if Left(item1(0), 2) <> Left(item2(0), 2) and tate1 = tate2 and _
					 ((tate1 and abs(p1(0)-p2(0)) < 0.0001) or ((not tate1) and abs(p1(1)-p2(1)) < 0.0001)) then
					if Instr(terms, Item1(0) & ",") = 0 then terms = terms & Item1(0) & ","
					if Instr(terms, Item2(0) & ",") = 0 then terms = terms & Item2(0) & ","
					Call lineWindow(p1, p2, 0.5, mnpt, mxpt)
					ss.clear
					Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
					if ss.Count > 0 then 
						for k = 0 to ss.Count - 1
							Set obj = ss.Item(k)
							'' Jbg
							if obj.EntityName = "AcDbLine" then
								stpt = ut.CreateSafeArrayFromVector(obj.StartPoint)
								edpt = ut.CreateSafeArrayFromVector(obj.EndPoint)
								if canBeJoint(stpt, edpt, p1, p2) then
									'ut.prompt "canbejoint"
									if inArea(stpt, mnpt, mxpt) then
										if distance(edpt, p1) < distance(edpt, p2) then
											obj.StartPoint = p1
										else
											obj.StartPoint = p2
										end if
										obj.Update
									elseif inArea(edpt, mnpt, mxpt) then
										if distance(stpt, p1) < distance(stpt, p2) then
											obj.EndPoint = p1
										else
											obj.EndPoint = p2
										end if
										obj.Update
									else
										Set obj2 = obj.Copy
										if distance(stpt, p1) < distance(stpt, p2) then
											obj.EndPoint = p1
											obj2.startpoint = p2
										else
											obj.EndPoint = p2
											obj2.startpoint = p1
										end if
										obj.Update
										obj2.Update							
										Set obj2 = Nothing
									end if
								else
									'ut.prompt "not canbejoint " & item1(0)
								end if
							end If
							Set obj = Nothing
						next
					end if
				end if
			next
		next
		'ut.prompt "terms=" & terms
		'' 2022/03/17
		'' ΂ɂȂĂȂ[_̃Jbg 
		for i = 0 to UBound(bjeTermArray)
			item1 = split(bjeTermArray(i), ",")
			if Instr(terms, Item1(0) & ",") = 0 then
				for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
				Call pointWindow(p1, 0.5, mnpt, mxpt)
				ss.clear
				Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
				if ss.Count > 0 then
					if ss.Count = 1 then
						'' P_JbgŎc̏
						'' X8 = 㑤svAX2 = svAX4 = EsvAX1 = sv
						s = Left(item1(0), 2)
						''ut.prompt s
						Set obj = ss.Item(0)

						'' 폜Ȃꍇ͉L̃RgO					
						' Set obj2 = obj.Copy
						' obj.EndPoint = p1
						' obj.Update
						' obj2.StartPoint = p1
						' obj2.Update
						' Set obj2 = Nothing

						'' 폜Ȃꍇ͈ȉRgAEg
						stpt = ut.CreateSafeArrayFromVector(obj.StartPoint)
						edpt = ut.CreateSafeArrayFromVector(obj.EndPoint)
						if s = "X1" then '' sv
							if stpt(0) > edpt(0) then
								obj.EndPoint = p1
							else
								obj.StartPoint = p1
							end if
						elseif s = "X4" then '' Esv
							if stpt(0) < edpt(0) then
								obj.EndPoint = p1
							else
								obj.StartPoint = p1
							end if
						elseif s = "X2" then '' sv
							if stpt(1) > edpt(1) then
								obj.EndPoint = p1
							else
								obj.StartPoint = p1
							end if
						elseif s = "X8" then '' 㑤sv
							if stpt(1) < edpt(1) then
								obj.EndPoint = p1
							else
								obj.StartPoint = p1
							end if							
						end if
						obj.Update

						Set obj = Nothing
						
					end if	
				end if			
			end if
		next
		' '' 2022/03/11 ̎ɑΉ
		' if (UBound(bjeTermArray) + 1) mod 2 > 0 then
		' 	item1 = split(bjeTermArray(UBound(bjeTermArray)), ",")
		' 	for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
		' 	Call pointWindow(p1, 0.5, mnpt, mxpt)
		' 	ss.clear
		' 	Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
		' 	if ss.Count > 0 then
		' 		if ss.Count = 1 then
		' 			Set obj = ss.Item(0)
		' 			Set obj2 = obj.Copy
		' 			obj.EndPoint = p1
		' 			obj2.StartPoint = p1
		' 			obj.Update
		' 			obj2.Update							
		' 			Set obj = Nothing
		' 			Set obj2 = Nothing
		' 		end if	
		' 	end if			
		' end if
	else
		' 2022/03/10
		' P_Jbg
		' X4TERM1,0.0000,-0.0000
		item1 = split(bjeTermArray(0), ",")
		s = Left(item1(0), 2)
		for j = 0 to 1: p1(j) = CDbl(item1(j + 1)) + blkpos(j): next
		Call pointWindow(p1, 0.5, mnpt, mxpt)
		ss.clear
		Call ss.Select(acSelectionSetCrossing, mnpt, mxpt, 0, "LINE")
		if ss.Count > 0 then
			if ss.Count = 1 then
				Set obj = ss.Item(0)
				' Set obj2 = obj.Copy
				' obj.EndPoint = p1
				' obj2.StartPoint = p1
				' obj.Update
				' obj2.Update
				' Set obj2 = Nothing

				'' 폜Ȃꍇ͈ȉRgAEg
				stpt = ut.CreateSafeArrayFromVector(obj.StartPoint)
				edpt = ut.CreateSafeArrayFromVector(obj.EndPoint)
				if s = "X1" then '' sv
					if stpt(0) > edpt(0) then
						obj.EndPoint = p1
					else
						obj.StartPoint = p1
					end if
				elseif s = "X4" then '' Esv
					if stpt(0) < edpt(0) then
						obj.EndPoint = p1
					else
						obj.StartPoint = p1
					end if
				elseif s = "X2" then '' sv
					if stpt(1) > edpt(1) then
						obj.EndPoint = p1
					else
						obj.StartPoint = p1
					end if
				elseif s = "X8" then '' 㑤sv
					if stpt(1) < edpt(1) then
						obj.EndPoint = p1
					else
						obj.StartPoint = p1
					end if							
				end if
				obj.Update
				
				Set obj = Nothing
			end if	
		end if
	end if
	
	Set ss = Nothing
	Set ut = Nothing
end sub

sub main()
	dim ticks: ticks = Timer

	dim ut: Set ut = ThisDrawing.Utility
	dim doc: Set doc = ThisDrawing

	Dim blockObj, blockPos, bjeTerms, bjeFlag
	dim minpt(2), maxpt(2)
	dim bjeTermArray
	Dim hnds: hnds = doc.getVariable("UserS1")
	'ut.prompt hnds
	Dim hndArray: hndArray = split(hnds, ",") 
	Dim cmd: cmd = ucase(doc.getVariable("UserS2")) '"BREAK" or "JOINT"
	'ut.prompt cstr(UBound(hndArray))
	if UBound(hndArray) >= 0 then
		dim h
		for h = 0 to UBound(hndArray)
			'ut.prompt hndArray(h)
			Set blockObj = doc.HandleToObject(hndArray(h))
			blockPos = ut.CreateSafeArrayFromVector(blockObj.InsertionPoint)
			'doc.ModelSpace.AddCircle blockPos, 0.25
			bjeTerms = getBjeTerms(blockObj)
			'ut.prompt "bjeTerms = " & bjeterms
			bjeFlag = bjeTerms <> ""
			'bjeFlag = false
			if bjeFlag then
				'ut.Prompt "Bje" 
				if toBjeTermArray(bjeTerms, bjeTermArray) then
					if cmd = "BREAK" then
						'ut.Prompt "break"
						call bjeBreakLines(bjeTermArray, blockPos)
					elseif cmd = "JOINT" then
						'ut.Prompt "joint"
						if getBjeRect(bjeTermArray, blockPos, minpt, maxpt) then
							'ut.Prompt "joint2"
							call jointLines(blockPos, minpt, maxpt)
						end if
					end if
				end if
			else
				'ut.Prompt "not Bje" 
				if blockRect(blockObj, minpt, maxpt) then
					' doc.ModelSpace.AddCircle minpt, 0.05
					' doc.ModelSpace.AddCircle maxpt, 0.1
					if cmd = "BREAK" then
						call breakLines(blockObj, minpt, maxpt)
					elseif cmd = "JOINT" then
						call jointLines(blockPos, minpt, maxpt)
					end if
				end if
			end if
			Set blockObj = Nothing
			doc.regen acActiveViewport
		next
	end if

	ut.prompt "VBS: " & FormatNumber((Timer - ticks) * 1000, 1) & " msec"
	'doc.SetVariable "FILEDIA", 1
	Set ut = Nothing
	Set doc = Nothing
end sub